/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.artifacts.uinfo.salix;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;
import org.dive4elements.artifacts.Artifact;
import org.dive4elements.artifacts.CallContext;
import org.dive4elements.artifacts.common.utils.XMLUtils.ElementCreator;
import org.dive4elements.river.artifacts.states.AddTableDataHelper;
import org.dive4elements.river.artifacts.states.DefaultState;
import org.w3c.dom.Element;

public class LoadSingleEpochSelectState extends DefaultState {
    private static final long serialVersionUID = 1L;
    /** The log used in this class. */
    private static Logger log = Logger.getLogger(LoadSingleEpochSelectState.class);

    /**
     * The default constructor that initializes an empty State object.
     */
    public LoadSingleEpochSelectState() {
    }

    @Override
    protected String getUIProvider() {
        return "common.load_single_epoch_select";
    }

    @Override
    protected void appendItems(final Artifact artifact, final ElementCreator creator, final String name, final CallContext context, final Element select) {
        final String datakey = "singleepoch";
        // TODO: MAKE DATASOURCE
        try {
            if (datakey.equals(name)) {

                final AddTableDataHelper helper = new AddTableDataHelper(creator, select, "year", context.getMeta());

                helper.addColumn(0, "pinfrom", "40", "common.client.ui.from", "ICON", "CENTER", "from");
                helper.addColumn(1, "pinto", "40", "common.client.ui.to", "ICON", "CENTER", "to");
                helper.addColumn(2, "year", "60", "year", "INTEGER", "LEFT", null);
                helper.addColumn(3, "sounding", "200", "uinfo.salix.soundings", "STRING", "LEFT", null);
                // final CollisionAccess access = new CollisionAccess((SINFOArtifact) artifact); // Der River wurde im vorigen State
                // bereits gesetzt

                // final List<Collision> collisions = CollisionHibernateFactory.getCollisionsByRiver(access.getRiver());
                // for (final Collision coll : collisions) { // TODO: Filter on Range (?)
                // final Integer year = coll.getYear();
                // for (final Collision coll : collisions) {
                for (int i = 0; i < 3; i++) {// : Collision.getYearsOfRiver(access.getRiver())) {
                    // final Integer year = coll.getYear();
                    final Map<String, String> row = new HashMap<>();
                    row.put("year", String.valueOf(1995 + i)); // Nullpointer?
                    row.put("sounding", "TODO: Peilungen für das Jahr in dieser Zelle auflisten.");
                    helper.addRow(row);
                }
                // }
                helper.submitMapToXml();
            }
        }
        catch (

        final IllegalArgumentException iae) {
            iae.printStackTrace();
        }
    }
}
